﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.3
@EndOfDesignText@
'Code Module Forum Solver
'Solver by Markus Stipp that won the quickest Sudoku solving competion in 2011 
'https://www.b4x.com/android/forum/threads/sudoku-solver-contest-we-have-a-winner.11834/


Sub Process_Globals	
	Dim allowedBitFields() As Int
	Dim allAllowed As Int
	Dim retNull(1,1) As Int

End Sub

Sub Globals

End Sub


Sub SolveSudoku	
	allowedBitFields = Array As Int(0,1,2,4,8,16,32,64,128,256)
	allAllowed = 511
	retNull(0,0) = -1
    Main.TotalCount = solveBoard(Main.cells)
End Sub


Sub solveBoard(board(,) As Int) As Int
'	Log("solveBoard")
	Dim allowedValues(9,9) As Int
	Dim placedNumberCount As Int

	For i = 0 To 8
		For j = 0 To 8
			allowedValues(i,j) = allAllowed
		Next
	Next

	For x = 0 To 8
		For y = 0 To 8
			If board(x,y) > 0 Then
				allowedValues(x,y) = 0
				applyAllowedValuesMask(board, allowedValues, x, y)
				placedNumberCount = placedNumberCount + 1
			End If
		Next
	Next

	Return solveBoard2(board, allowedValues, placedNumberCount)
End Sub


Sub solveBoard2(board(,) As Int, allowedValues(,) As Int, placedNumberCount As Int) As Int
'	Log("solveBoard2")
	Dim lastPlacedNumbersCount As Int
	
	Do While (placedNumberCount - lastPlacedNumbersCount > 5) And (placedNumberCount < 70)
		lastPlacedNumbersCount = placedNumberCount
		placedNumberCount = placedNumberCount + ApplyRule1(board, allowedValues)
		placedNumberCount = placedNumberCount + ApplyRule2(board, allowedValues)

		If (placedNumberCount - lastPlacedNumbersCount) < 7 Then
			placedNumberCount = placedNumberCount + applyRule3(board, allowedValues)
		Else
			placedNumberCount = placedNumberCount + ApplyRule1(board, allowedValues)
		End If
		
		If placedNumberCount < 45 Then
			applyNakedPairs(allowedValues)
		End If
		If placedNumberCount < 35 Then
			applyLineCandidateConstraints(allowedValues)
		End If
	Loop

	'If the rules do not find anything anymore we do a backtracking.
	If placedNumberCount < 81 Then
		Dim BacktrackBoard(,) As Int
		BacktrackBoard = doBacktrack(board, allowedValues, placedNumberCount)

		If BacktrackBoard(0,0) <> -1 Then
			placedNumberCount = 0

			For x = 0 To 8
				For y = 0 To 8
					board(x,y) = BacktrackBoard(x,y)
					If BacktrackBoard(x,y) > 0 Then
						placedNumberCount = placedNumberCount + 1
					End If
				Next
			Next
		End If
	End If

	Return placedNumberCount
End Sub


Sub ApplyRule1(board(,) As Int, allowedValues(,) As Int) As Int
	'Log("ApplyRule1")
	Dim moveCount As Int
	Dim currentAllowedValues As Int

	For x = 0 To 8
		For y = 0 To 8
			If board(x,y) = 0 Then
				currentAllowedValues = allowedValues(x,y)
				If countSetBits(currentAllowedValues) = 1 Then
					'setValue(board, allowedValues, getLastSetBitIndex(currentAllowedValues), x, y)
					board(x,y) = getLastSetBitIndex(currentAllowedValues)
					allowedValues(x,y) = 0
					applyAllowedValuesMask(board, allowedValues, x, y)
					moveCount = moveCount + 1
				End If
			End If
		Next
	Next

	Return moveCount
End Sub


Sub ApplyRule2(board(,) As Int, allowedValues(,) As Int) As Int
	'Log("ApplyRule2")
	Dim moveCount As Int
	Dim allowedBitField, allowedY, allowedX As Int

	For value = 1 To 9
		allowedBitField = allowedBitFields(value)
		For x = 0 To 8
			allowedY = -1
			For y = 0 To 8
				If Bit.And(allowedValues(x, y), allowedBitField) > 0 Then
					If allowedY < 0 Then
						allowedY = y
					Else
						allowedY = -1
						Exit
					End If
				End If
			Next
			If allowedY >= 0 Then
				'setValue(board, allowedValues, value, x, allowedY)
				board(x,allowedY) = value
				allowedValues(x,allowedY) = 0
				applyAllowedValuesMask(board, allowedValues, x, allowedY)

				moveCount = moveCount + 1
			End If
		Next
		For y = 0 To 8
			allowedX = -1
			For x = 0 To 8
				If Bit.And(allowedValues(x,y), allowedBitField) > 0 Then
					If allowedX < 0 Then
						allowedX = x
					Else
						allowedX = -1
						Exit
					End If
				End If
			Next

			If allowedX >= 0 Then
				'setValue(board, allowedValues, value, allowedX, y)
				board(allowedX,y) = value
				allowedValues(allowedX,y) = 0
				applyAllowedValuesMask(board, allowedValues, allowedX, y)
				
				moveCount = moveCount + 1
			End If
		Next
	Next

	Return moveCount
End Sub


Sub applyRule3(board(,) As Int, allowedValues(,) As Int) As Int
	'Log("ApplyRule3")
	Dim moveCount As Int
	Dim allowedX, allowedY As Int
	Dim sectionEndX, sectionEndY As Int
	Dim allowedBitField As Int
	Dim vExit As Boolean : vExit = False
	For sectionX = 0 To 8 Step 3
		For sectionY = 0 To 8 Step 3
			For value = 1 To 9
				allowedX = -1
				allowedY = -1
				sectionEndX = sectionX + 3
				sectionEndY = sectionY + 3
				allowedBitField = allowedBitFields(value)
				For x = sectionX To sectionEndX - 1
					For y = sectionY To sectionEndY - 1
						If Bit.And(allowedValues(x,y), allowedBitField) > 0 Then
							If allowedX < 0 Then
								allowedX = x
								allowedY = y
							Else
								allowedX = -1
								vExit = True
								Exit
							End If
						End If
					Next
					If vExit = True Then
						vExit = False
						Exit
					End If
				Next
				If allowedX >= 0 Then
					'setValue(board, allowedValues, value, allowedX, allowedY)
					board(allowedX,allowedY) = value
					allowedValues(allowedX,allowedY) = 0
					applyAllowedValuesMask(board, allowedValues, allowedX, allowedY)

					moveCount = moveCount + 1
				End If
			Next
		Next
	Next

	Return moveCount
End Sub


Sub doBacktrack(board(,) As Int, allowedValues(,) As Int, placedNumberCount As Int) As Int(,)
	'Log("doBacktrack")
	Dim testBoard(,) As Int
	Dim testAllowedValues(,) As Int
	Dim placedNumbers As Int

	For x = 0 To 8
		For y = 0 To 8
			If board(x,y) = 0 Then
				For value = 1 To 9
					If Bit.And(allowedValues(x,y), allowedBitFields(value)) > 0 Then
						testBoard = copyMatrix(board)
						testAllowedValues = copyMatrix(allowedValues)
						'setValue(testBoard, testAllowedValues, value, x, y)
						testBoard(x,y) = value
						testAllowedValues(x,y) = 0
						applyAllowedValuesMask(testBoard, testAllowedValues, x, y)
						placedNumbers = solveBoard2(testBoard, testAllowedValues, placedNumberCount + 1)
						If placedNumbers = 81 Then
							Return testBoard
						End If
					End If
				Next
				Return retNull
			End If
		Next
	Next
	Return retNull
End Sub


Sub applyNakedPairs(allowedValues(,) As Int)
'	Log("applyNakedPairs")
	Dim value As Int
	Dim removeMask As Int

	For x = 0 To 8
		For y = 0 To 8
			value = allowedValues(x,y)
			If countSetBits(value) = 2 Then
				For scanningY = y + 1 To 8
					If allowedValues(x, scanningY) = value Then
						removeMask = Bit.Not(value)
						For applyY = 0 To 8
							If applyY <> y And applyY <> scanningY Then
								allowedValues(x, applyY) = Bit.And(allowedValues(x, applyY), removeMask)
							End If
						Next
					End If
				Next
			End If
		Next
	Next

	For y = 0 To 8
		For x = 0 To 8
			value = allowedValues(x,y)
			If value <> 0 And countSetBits(value) = 2 Then
				For scanningX = x + 1 To 8
					If allowedValues(scanningX, y) = value Then
						removeMask = Bit.Not(value)
						For applyX = 0 To 8
							If applyX <> x And applyX <> scanningX Then
								allowedValues(applyX,y) = Bit.And(allowedValues(applyX,y), removeMask)
							End If
						Next
					End If
				Next
			End If
		Next
	Next
End Sub


Sub applyLineCandidateConstraints(allowedValues(,) As Int)
	'Log("applyLineCandidateConstraints")
	Dim valueMask, valueRemoveMask As Int
	Dim bitCount As Int

	For value = 1 To 9
		valueMask = allowedBitFields(value)
		valueRemoveMask = Bit.Not(valueMask)

		Dim sectionAvailabilityColumn(9) As Int
		For x = 0 To 8
			For y = 0 To 8
				If Bit.And(allowedValues(x,y), valueMask) <> 0 Then
					sectionAvailabilityColumn(x) = Bit.Or(sectionAvailabilityColumn(x), Bit.ShiftLeft(1, (y/3)))
				End If
			Next

			If x = 2 Or x = 5 Or x = 8 Then
				For scanningX = x - 2 To x
					bitCount = countSetBits(sectionAvailabilityColumn(scanningX))

					If bitCount = 1 Then
						For applyX = x - 2 To x
							If scanningX <> applyX Then
								For applySectionY = 0 To 2
									If Bit.And(sectionAvailabilityColumn(scanningX), Bit.ShiftLeft(1, applySectionY)) <> 0 Then
										For applyY = applySectionY * 3 To ((applySectionY + 1) * 3) - 1
											allowedValues(applyX, applyY) =  Bit.And(allowedValues(applyX, applyY), valueRemoveMask)
										Next
									End If
								Next
							End If
						Next
					End If

					If (bitCount = 2) And (scanningX < x) Then
						For scanningSecondPairX = scanningX + 1 To x
							If sectionAvailabilityColumn(scanningX) = sectionAvailabilityColumn(scanningSecondPairX) Then
								If scanningSecondPairX <> x Then
									applyX = x
								Else If (scanningSecondPairX - scanningX) > 1 Then
									applyX = scanningSecondPairX - 1
								Else
									applyX = scanningX - 1
								End If

								For applySectionY = 0 To 2
									If Bit.And(sectionAvailabilityColumn(scanningX), Bit.ShiftLeft(1, applySectionY)) <> 0 Then
										For applyY = applySectionY * 3 To ((applySectionY + 1) * 3) - 1
											allowedValues(applyX, applyY) = Bit.And(allowedValues(applyX, applyY), valueRemoveMask)
										Next
									End If
								Next
								Exit
							End If
						Next
					End If
				Next
			End If
		Next

		Dim sectionAvailabilityRow(9) As Int
		For y = 0 To 8
			For x = 0 To 8
				If Bit.And(allowedValues(x, y), valueMask) <> 0 Then
					sectionAvailabilityRow(y) = Bit.Or(sectionAvailabilityRow(y), Bit.ShiftLeft(1, (x/3)))
				End If
			Next

			If y = 2 Or y = 5 Or y = 8 Then
				For scanningY = y - 2 To y
					bitCount = countSetBits(sectionAvailabilityRow(scanningY))

					If bitCount = 1 Then
						For applyY = y - 2 To y
							If scanningY <> applyY Then
								For applySectionX = 0 To 2
									If Bit.And(sectionAvailabilityRow(scanningY), Bit.ShiftLeft(1, applySectionX)) <> 0 Then
										For applyX = applySectionX * 3 To ((applySectionX + 1) * 3) - 1
											allowedValues(applyX, applyY) = Bit.And(allowedValues(applyX, applyY), valueRemoveMask)
										Next
									End If
								Next
							End If
						Next
					End If

					If bitCount = 2 And scanningY < y Then
						For scanningSecondPairY = scanningY + 1 To y
							If sectionAvailabilityRow(scanningY) = sectionAvailabilityRow(scanningSecondPairY) Then
								If scanningSecondPairY <> y Then
									applyY = y
								Else If (scanningSecondPairY - scanningY) > 1 Then
									applyY = scanningSecondPairY - 1
								Else
									applyY = scanningY - 1
								End If

								For applySectionX = 0 To 2
									If Bit.And(sectionAvailabilityRow(scanningY), Bit.ShiftLeft(1, applySectionX)) <> 0 Then
										For applyX = applySectionX * 3 To ((applySectionX + 1) * 3) - 1
											allowedValues(applyX, applyY) = Bit.And(allowedValues(applyX, applyY), valueRemoveMask)
										Next
									End If
								Next
							End If
						Next
					End If
				Next
			End If
		Next
	Next
End Sub

'Inlined, now obsolete
'Sub setValue(board(,) As Int, allowedValues(,) As Int, value As Int, x As Int, y As Int)
'	board(x,y) = value
'	allowedValues(x,y) = 0
'	applyAllowedValuesMask(board, allowedValues, x, y)
'End Sub


Sub getLastSetBitIndex(value As Int) As Int
	'Log("getLastSetBitIndex")
	Dim bitIndex As Int

	Do While value > 0
		bitIndex = bitIndex + 1
		value = Bit.ShiftRight(value, 1)
	Loop

	Return bitIndex
End Sub


Sub applyAllowedValuesMask(board(,) As Int, allowedValues(,) As Int, x As Int, y As Int)
'	Log("applyAllowedValuesMask")
	Dim mask As Int
	Dim sectionX1, sectionX2 As Int
	Dim sectionY1, sectionY2 As Int

	mask = Bit.Not(allowedBitFields(board(x,y)))

	For maskApplyX = 0 To 8
		allowedValues(maskApplyX, y) = Bit.And(allowedValues(maskApplyX, y), mask)
	Next

	For maskApplyY = 0 To 8
		allowedValues(x, maskApplyY) = Bit.And(allowedValues(x, maskApplyY), mask)
	Next
	
	Select x
		Case 0, 3, 6
			sectionX1 = x + 1
			sectionX2 = x + 2

		Case 1, 4, 7
			sectionX1 = x - 1
			sectionX2 = x + 1

		Case 2, 5, 8
			sectionX1 = x - 2
			sectionX2 = x - 1
	End Select

	Select y
		Case 0, 3, 6
			sectionY1 = y + 1
			sectionY2 = y + 2

		Case 1, 4, 7
			sectionY1 = y - 1
			sectionY2 = y + 1

		Case 2, 5, 8
			sectionY1 = y - 2
			sectionY2 = y - 1
	End Select

	allowedValues(sectionX1,sectionY1) = Bit.And(allowedValues(sectionX1,sectionY1), mask)
	allowedValues(sectionX1,sectionY2) = Bit.And(allowedValues(sectionX1,sectionY2), mask)
	allowedValues(sectionX2,sectionY1) = Bit.And(allowedValues(sectionX2,sectionY1), mask)
	allowedValues(sectionX2,sectionY2) = Bit.And(allowedValues(sectionX2,sectionY2), mask)
End Sub


Sub countSetBits(value As Int) As Int
	'Log("countSetBits")
	Dim count As Int
	Do While value > 0 And count < 4
		value = Bit.And(value, (value - 1))
		count = count + 1
	Loop
	Return count
End Sub


Sub copyMatrix(matrix(,) As Int) As Int(,)
	'Log("copyMatrix")
	Dim retMatrix(9,9) As Int
	For i = 0 To 8
		For j = 0 To 8
			retMatrix(i,j) = matrix(i,j)
		Next
	Next
	Return retMatrix
End Sub
